<?php
/**
 * $Horde: wicked/attachment.php,v 1.5 2005/01/03 14:35:46 jan Exp $
 *
 * Copyright 2004-2005 Cronosys, LLC <http://www.cronosys.com/>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

@define('WICKED_BASE', dirname(__FILE__));
require_once WICKED_BASE . '/lib/base.php';
require_once 'Horde/MIME/Magic.php';

$page = Util::getFormData('page');
$file = Util::getFormData('file');
$mime = Util::getFormData('mime');

if (!empty($_SERVER['HTTP_REFERER'])) {
    $referer = $_SERVER['HTTP_REFERER'];
} else {
    $referer = Horde::applicationUrl('display.php', true);
    $referer = Util::addParameter($referer, 'page', $page);
}

$version = Util::getFormData('version');
if (empty($version)) {
    $attachments = $wicked->getAttachedFiles($page);
    if (is_a($attachments, 'PEAR_Error')) {
        $notification->push($data->getMessage(), 'horde.error');
        header('Location: ' . $referer);
        exit;
    }

    foreach ($attachments as $attachment) {
        if ($attachment['attachment_name'] == $file) {
            $version = $attachment['attachment_majorversion'] . '.' .
                       $attachment['attachment_minorversion'];
        }
    }

    if (empty($version)) {
        $notification->push(sprintf(_("No such attachment '%s'."), $file));
        header('Location: ' . $referer);
        exit;
    }
}

$data = $wicked->getAttachmentContents($page, $file, $version);
if (is_a($data, 'PEAR_Error')) {
    $notification->push($data->getMessage(), 'horde.error');
    header('Location: ' . $referer);
    exit;
}

$type = 'application/octet-stream';
if (!empty($mime)) {
    $type = MIME_Magic::analyzeData($data);
    if ($type === false) {
        $type = MIME_Magic::filenameToMIME($file, false);
    }
}

$browser->downloadHeaders($file, $type, !empty($mime), strlen($data));
echo $data;
