<?php

require_once WICKED_BASE . '/lib/Page/StandardPage.php';

/**
 * Wicked AllPages class.
 *
 * $Horde: wicked/lib/Page/AllPages.php,v 1.4 2004/08/11 00:26:34 eraserhd Exp $
 *
 * @author  Tyler Colbert <tyler-hordeml@colberts.us>
 * @version $Revision: 1.4 $
 * @package Wicked
 */
class AllPages extends Page {

    /**
     * Display modes supported by this page.
     */
    var $supportedModes = array(
        WICKED_MODE_CONTENT => true,
        WICKED_MODE_DISPLAY => true);

    /**
     * Render this page in Content mode.
     *
     * @return string  The page content, or PEAR_Error.
     */
    function content()
    {
        global $wicked;

        return $wicked->getAllPages();
    }

    /**
     * Render this page in display or block mode.
     *
     * @return mixed  Returns page contents or PEAR_Error
     */
    function displayContents($isBlock)
    {
        $summaries = $this->content();
        if (is_a($summaries, 'PEAR_Error')) {
            global $notification;
            $notification->push('Error retrieving summaries : ' .
                                $summaries->toString(), 'horde.error');
            return $summaries;
        }

        require_once 'Horde/Template.php';
        $template = &new Horde_Template();
        $pages = array();
        foreach ($summaries as $page) {
            $page = &new StandardPage($page);
            $pages[] = array('author' => $page->author(),
                             'created' => $page->formatVersionCreated(),
                             'name' => $page->pageName(),
                             'url' => $page->pageUrl(),
                             'version' => $page->version());
        }
        $template->set('pages', $pages);

        // Show search form and page header.
        ob_start();
        require WICKED_TEMPLATES . '/pagelist/header.inc';
        echo $template->fetch(WICKED_TEMPLATES . '/pagelist/pagelist.html');
        require WICKED_TEMPLATES . '/pagelist/footer.inc';
        $contents = ob_get_contents();
        ob_end_clean();
        return $contents;
    }

    function pageName()
    {
        return _("AllPages");
    }

    function pageUrl($linkpage = 'display.php', $actionid = null)
    {
        $url = Horde::applicationUrl($linkpage);
        return Util::addParameter($url, 'page', 'AllPages');
    }

}
