<?php

require_once WICKED_BASE . '/lib/Page/StandardPage.php';

/**
 * Wicked LikePages class.
 *
 * $Horde: wicked/lib/Page/LikePages.php,v 1.13 2004/08/03 18:57:19 eraserhd Exp $
 *
 * @author  Tyler Colbert <tyler-hordeml@colberts.us>
 * @version $Revision: 1.13 $
 * @package Wicked
 */
class LikePages extends Page {

    /**
     * Display modes supported by this page.
     * @var array $supportedModes
     */
    var $supportedModes = array(
        WICKED_MODE_DISPLAY => true);

    /**
     * The page that we're displaying similar pages to.
     * @var string $_referrer
     */
    var $_referrer = null;

    function LikePages($referrer)
    {
        $this->_referrer = $referrer;
    }

    /**
     * Render this page in Display mode.
     *
     * @return mixed                Returns true or PEAR_Error.
     */
    function display()
    {
        global $wicked;

        $referrer = $this->referrer();

        $summaries = $wicked->getLikePages($referrer);
        if (is_a($summaries, 'PEAR_Error')){
            global $notification;
            $notification->push('Error retrieving summaries: ' .
                                $summaries->toString(), 'horde.error');
            return $summaries;
        }

        require WICKED_TEMPLATES . '/pagelist/header.inc';
        foreach ($summaries as $page) {
            if (!empty($page['page_history'])){
                $page = &new StdHistoryPage($page);
            } else {
                $page = &new StandardPage($page);
            }
            require WICKED_TEMPLATES . '/pagelist/summary.inc';
        }
        require WICKED_TEMPLATES . '/pagelist/footer.inc';

        return true;
    }

    function pageName()
    {
        return sprintf(_("LikePages: %s"), $this->referrer());
    }

    function referrer()
    {
        return $this->_referrer;
    }

    function pageUrl($linkpage = 'display.php', $actionid = 'none')
    {
        $url = Horde::applicationUrl($linkpage);
        $url = Util::addParameter($url, 'page', $this->pageName());
        $url = Util::addParameter($url, 'referrer', $this->referrer());
        return Util::addParameter($url, 'actionID', $actionid);
    }

}
